<?php
/*
Wax Poteto by Marc "Waccoon" Leveille, http://www.NineChime.com/products/
Version 5.5.13 - Last modified 5/21/2007

Autoglobal workaround by BoogiePanda
	web: http://people.engr.ncsu.edu/jthurtea/
	old: http://www4.ncsu.edu/~jthurtea/

Note: config, dbconn included at end of file.  Add db/config dependent code to end!
*/


// Set error reporting to exclude notices
error_reporting (E_ALL ^ E_NOTICE);

// Fix for DomainStats, which corrupts templates, banners, etc.
if (!defined ('domainstat')) {
	define ('domainstat', 'ok');
}

// Cookies
$cookie_life = 2419200;

// Set runtime quotes and filter
if (!get_magic_quotes_gpc()) {
	function slash_it($in){
		return addslashes($in);
	}
} else {
	set_magic_quotes_runtime(0);

	function slash_it($in){
		return $in;
	}
}


function registerGlobals() {
	// Off for Wax
	//foreach( $_FILES as $varname => $varval ){
	//	$GLOBALS[$varname] = $varval;
	//}

	foreach( $_GET as $varname => $varval ){
		$GLOBALS[$varname] = slash_it($varval);
	}

	foreach( $_POST as $varname => $varval ){
		$GLOBALS[$varname] = slash_it($varval);
	}

	foreach( $_COOKIE as $varname => $varval ){
		$GLOBALS[$varname] = slash_it($varval);
	}

	// Off for Wax
	//foreach( $_SESSION as $varname => $varval ){
	//	$GLOBALS[$varname] = $varval;
	//}

	// Off for Wax
	//foreach( $_SERVER as $varname => $varval ){
	//	$GLOBALS[$varname] = $varval;
	//}
}

registerGlobals();


// Clean up some reg globals
$usrflags = '';
$row = array();
$flags = '';
$uflags = '';


function all_done($location = 'index.php') {
	// Blank location sends to index.php
	// "${loc};in" logs in, "${loc};out" logs out
	global $dbconn;
	@mysql_close($dbconn);

	$url = $location;

	// Hack to fix IIS cookie issue
	if (strstr ($location, ';')) {
		list ($url, $stat) = explode (';', $location);

		if (strstr (strtoupper ($_SERVER['SERVER_SOFTWARE']), 'IIS/')) {
			if ($stat == 'in') {
				$mess = 'Thanks for logging in!';
			} elseif ($stat == 'out') {
				$mess = 'You have sucessfully logged out.';
			} else {
				$mess = 'Your login has been updated.';
			}

			echo <<<EOF
<html>
<head>
	<title>Redirect</title>
	<meta http-equiv="refresh" content="3;url={$url}">
</head>
<body>
	<p style="text-align: center; padding: 15px; border: 2px black solid;">
		<strong>{$mess}</strong><br /><br />If you are not redirected in 3 seconds, click <a href="{$url}">here</a>.
	</p>
</body>
</html>
EOF;
			exit ();
		}
	}

	header ('Location: '.$url);
	exit;
}

function report_err($error = '') {
	global $dbconn;
	@mysql_close($dbconn);

	if (empty ($error)) {
		$error = 'An error occured.  Please try again.';
	}

	header ('Location: error.php?error='.urlencode($error));
	exit;
}

function check_flag($c) {
	global $usrflags;
	return is_integer(strpos($usrflags, $c));
}


// Deluxe page numbers
// Takes a keyed array of paramaters ($in) and returns an HTML-formatted block of page numbers
function full_page_numbers($first, $current, $total, $display, $link, $in) {
	/*
	$first = First page number.  Some BBSes use 0 as the first page, others 1.
	$display = Number of pages to show per side of the current page.  0 = use default.

	$in = array:
	prev_enabled  => Linked "Prev", parsed for '{page}'
	prev_disabled => Unlinked "Prev"
	next_enabled  => Linked "Next", parsed for '{page}'
	next_disabled => Unlinked "Next"
	button_sep    => Seperates Prev/Next from numbers
	link_format   => Link format (for classes, etc), parsed for '{page}'
	active_format => Span for current [active] number, parsed for '{page}'
	elipses       => Seperator for first/last numbers and all others
	page_sep      => Seperator between numbers
	*/

	// Fixes offset issue with some BBSes
	function offset_replace($offset, $number, $string) {
		$old = array ('{page_link}', '{page}');
		$new = array ($number + $offset, $number);
		return str_replace ($old, $new, $string);
	}

	// Set up
	$output = '';
	if ($display < 1) {
		$display = 4;
	}
	if ($first == 0) {
		$offset = -1;
		$first += 1;
		$current += 1;
	} else {
		$offset = 0;
	}
	$page_link = str_replace ('{link}', $link, $in['link_format']);
	$in['prev_enabled'] = str_replace ('{link}', $link, $in['prev_enabled']);
	$in['next_enabled'] = str_replace ('{link}', $link, $in['next_enabled']);

	// Get our extremes
	$list_start = 1;
	$list_end   = $total;
	if ($current > $display + 1) {
		$list_start = $current - $display;
	}
	if ($total - $current > $display) {
		$list_end = $current + $display;
	}

	// Print start block
	if ($current > 1) {
		$output .= offset_replace($offset, $current - 1, $in['prev_enabled']);
	} else {
		$output .= $in['prev_disabled'];
	}
	$output .= $in['button_sep'];

	// Print start number?
	if ($list_start > 1) {
		$output .= offset_replace($offset, 1, $page_link);
		$output .= $in['elipses'];
	}

	// Print all numbers
	for ($i = $list_start; $i <= $list_end; $i++) {
		if ($i == $current) {
			$output .= offset_replace($offset, $i, $in['active_format']);
		} else {
			$output .= offset_replace($offset, $i, $page_link);
		}
		if ($i != $list_end) $output .= $in['page_sep'];
	}

	// Print end number?
	if ($list_end < $total) {
		$output .= $in['elipses'];
		$output .= offset_replace($offset, $total, $page_link);
	}

	// Print end block
	$output .= $in['button_sep'];
	if ($current < $total) {
		$output .= offset_replace($offset, $current + 1, $in['next_enabled']);
	} else {
		$output .= $in['next_disabled'];
	}

	return $output;
}


// Simple page numbers (no images)
// Easy, format-free wrapper for full_page_numbers()
function quick_page_numbers($first, $current, $total, $display, $link) {
	$page_settings = array (
		'prev_enabled'  => '<a href="{link}">&lt;&lt;<b>PREV</b></a>',
		'prev_disabled' => '&lt;&lt;<b>PREV</b>',
		'next_enabled'  => '<a href="{link}"><b>NEXT</b>&gt;&gt;</a>',
		'next_disabled' => '<b>NEXT</b>&gt;&gt;',
		'button_sep'    => ' &middot; ',
		'link_format'   => '<a href="{link}">[{page}]</a>',
		'active_format' => '<b>[{page}]</b>',
		'elipses'       => ' ... ',
		'page_sep'      => ' '
	);

	return full_page_numbers($first, $current, $total, $display, $link, $page_settings);
}


// Crypt w/out key visible to public
function w_crypt($in) {
	global $saltenc;

	$out = crypt ($in, $saltenc);
	return (substr ($out, 2));
}


// Call after registerGlobals()!
if (!defined ('NO_RESOURCES')) {
	$cfg_draw_immune = 'no';
	$scale = 0;
	$scale_pix = 150;
	$use_c_avatars = 'no';

	if (!@include ('config.php')) {
		if (!file_exists ('config.php')) {
			echo "<html>\n<body\n<p>\nClick here to <a href=\"install.php\">run the installer</a>.\n</body>\n</html>";
			exit;
		} else {
			exit ('Config file unreadable!');
		}
	}

	if (!@include ('dbconn.php')) {
		exit ('Database config file unreadable!');
	}
	if ($wax_cfg_ver != '5.5.6') {
		exit ('Please run the <a href="update.php">updater</a>.');
	}
}

?>