<?php
/*
Updater from OekakiPoteto version 4.x to 5.x

OekakiPoteto 5.x Copyright 2000-2002 RanmaGuy (Theo Chakkapark, http://suteki.nu) and Marcello Basta-Forte (http://marcello.cellosoft.com). Modification to the files are permitted as long as my name remains on the files.

Wax Poteto by Marc "Waccoon" Leveille, http://www.NineChime.com/products/
Version 5.5.7 - Last modified 3/19/2006
*/

define ('NO_RESOURCES', 1);
require ('globals.php');
if (!@include ('config.php')) {
	exit ('Config file unreadable!');
}
if (!@include ('dbconn.php')) {
	exit ('Database config file unreadable!');
}


// Updater version
$update_ver = '5.5.6';

// Init
$debug = 0;
$mem = $OekakiPoteto_MemberPrefix;
$pre = $OekakiPoteto_Prefix;
$sql_errors = array();

function run_q($query) {
	global $sql_errors, $debug;

	if ($debug) {
		web_line ('DEBUG:  '.$query);
	}
	$result = mysql_query ($query);
	if (!$result) {
		$sql_errors[] = mysql_error();
	} else {
		return ($result);
	}
}

function web_line($in = '') {
	echo ($in."<br />\n");
}

function fail_exit() {
	global $dbconn;

	mysql_close ($dbconn);
	web_line ();
	web_line ('If problems persist, try visiting the <a href="http://www.ninechime.com/forum/">NineChime Support Forum</a>.');
	exit();
}

function fix_cfg_quotes($in) {
	/*
		Strip ALL backslashes and replace with proper quotes.  Due to OP quirks, single quotes should be left alone.
		Consecutive backslashes are a big problem with OP 5.x.
		Note that html decoders are mostly PHP5, and not in all RCs, either.  Grr.
	*/

	$in = str_replace ('\\', '', $in);
	$in = str_replace ('"', '&quot;', $in);
	$in = addslashes ($in);
	$in = str_replace ("\\'", '\'', $in);

	return ($in);
}

function get_fields($table) {
	global $dbconn;
	$names = array();

	$result = mysql_query ("SHOW FIELDS FROM ".$table);
	if ($result) {
		$rows = mysql_num_rows ($result);
		for ($i=0; $i < $rows; $i++) {
			$temp = mysql_fetch_row ($result);
			$names[] = $temp[0];
		}
		return ($names);
	} else {
		return (FALSE);
	}
}


// Determine oekaki version
{
	// OP 4
	$oe_version = '4.0.0';

	// OP 5
	if (isset ($jpgcompression) && empty ($wax_cfg_ver))
		$oe_version = '5.0.0';

	// Wax
	if (isset ($wax_cfg_ver))
		$oe_version = $wax_cfg_ver;
}


// Mode
if (!isset ($_GET['do'])) {
	if ($oe_version == $update_ver) {
		$mess1 = "Latest version of Wax detected ({$oe_version})";
		$mess2 = "You may safely remove the updater.";
	} else {
		$mess1 = "Detected version of OekakiPoteto:  {$oe_version}";
		$mess2 = "<a href=\"{$_SERVER['PHP_SELF']}?do=1\">Click here to start the update</a>.";
	}
echo <<<EOF
<html>
<head>
	<title>OP to Wax Update</title>
</head>

<body>
	<p>
		{$mess1}
	</p>
	<p>
		{$mess2}
	</p>
</body>
</html>
EOF;
	exit();
}


// Prechecks
{
	$fail = 0;
	if (!is_writable ('config.php')) {
		$fail = 1;
		web_line ('<strong>STOP</strong>:  &ldquo;config.php&rdquo; file is not writable.  CHMOD it before continuing.');
	}
	if (!is_writable ('dbconn.php')) {
		$fail = 1;
		web_line ('<strong>STOP</strong>:  &ldquo;dbconn.php&rdquo; file is not writable.  CHMOD it before continuing.');
	}
	if ($oe_version == '4.0.0' && !file_exists ('count')) {
		$fail = 1;
		web_line ('<strong>STOP</strong>:  &ldquo;count&rdquo; file cannot be found!  Check your board for corruption.');
	}
	if ($fail) {
		fail_exit();
	}

	// Detect apostrophes mode
	if (!get_magic_quotes_gpc()) {
		$apostrophes = '1';
	} else {
		$apostrophes = '0';
	}

	// Fix messed up config settings
	$BBStitle = fix_cfg_quotes ($BBStitle);
}


// OK, we're ready.  Now, we switch
switch ($oe_version) {
	case ('4.0.0'):
		// Lots of stuff to update
		run_q ("ALTER TABLE {$pre}oekakichat RENAME {$mem}oekakichat");
		run_q ("ALTER TABLE {$pre}oekakionline RENAME {$mem}oekakionline");
		run_q ("ALTER TABLE {$pre}oekakikill RENAME {$mem}oekakikill");
		run_q ("ALTER TABLE {$mem}oekakionline ADD onlineboard TEXT NOT NULL DEFAULT ''");
		run_q ("ALTER TABLE {$mem}oekaki CHANGE commcount commcount INT(11) DEFAULT 0 NOT NULL");
		run_q ("ALTER TABLE {$mem}oekaki CHANGE piccount piccount INT(11) DEFAULT 0 NOT NULL");
		run_q ("ALTER TABLE {$mem}oekakionline CHANGE OID OID BIGINT(255) NOT NULL AUTO_INCREMENT");
		run_q ("ALTER TABLE {$mem}oekakionline CHANGE locale locale VARCHAR(30) DEFAULT NULL");
		run_q ("ALTER TABLE {$pre}oekakidta CHANGE PIC_ID PIC_ID int(11) DEFAULT 0 NOT NULL");
		run_q ("ALTER TABLE {$pre}oekakidta CHANGE edittime edittime int(20) unsigned default NULL");
		run_q ("ALTER TABLE {$pre}oekakidta ADD postlock tinyint(4) NOT NULL default 0 ");
		run_q ("ALTER TABLE {$mem}oekaki ADD age text DEFAULT ''");
		run_q ("ALTER TABLE {$pre}oekakidta ADD animation tinyint(2) default 0");
		run_q ("ALTER TABLE {$mem}oekaki ADD gender text DEFAULT ''");
		run_q ("UPDATE {$pre}oekakidta SET postlock='1'");

		run_q ("CREATE TABLE IF NOT EXISTS {$mem}oekakimailbox (MID int(11) NOT NULL auto_increment, sender varchar(255) NOT NULL default '', reciever varchar(255) NOT NULL default '', subject text NOT NULL DEFAULT '', body longtext NOT NULL DEFAULT '', mstatus smallint(10) NOT NULL default 0, senddate datetime NOT NULL default '0000-00-00 00:00:00', PRIMARY KEY (MID), KEY sender(sender), KEY reciever (reciever))");
		run_q ("ALTER TABLE {$mem}oekaki ADD language TEXT NOT NULL DEFAULT ''");
		run_q ("UPDATE {$mem}oekaki SET language='english'");

		run_q ("CREATE TABLE IF NOT EXISTS {$pre}oekakimisc (MiscID int(11) NOT NULL auto_increment, miscname varchar(255) NOT NULL default '', miscvalue bigint(255) NOT NULL DEFAULT 0, PRIMARY KEY (MiscID), KEY miscname (miscname))");

		$resno = 0;
		if (file_exists ('count')) {
			$count_filesize = filesize ('count');
			$fp2 = @fopen ('count', 'r');
			if ($fp2) {
				$resno = (int) fread ($fp2, $count_filesize);
				fclose ($fp2);
			}
		}

		run_q ("INSERT INTO {$pre}oekakimisc VALUES (1, 'piccount', $resno)");
		run_q ("ALTER TABLE {$mem}oekaki ADD picview TINYINT(11) DEFAULT 0 NOT NULL");

		run_q ("CREATE TABLE IF NOT EXISTS {$mem}oekakichatmod (usrname varchar(255) NOT NULL default '', command varchar(32) NOT NULL default 'MESSAGE', comment tinytext NOT NULL DEFAULT '', posttime timestamp(14) NOT NULL, hostname text NOT NULL DEFAULT '', email varchar(255) DEFAULT NULL, url text  DEFAULT '', IP text NOT NULL, postname varchar(50) NOT NULL default '', PRIMARY KEY (posttime)) TYPE=MyISAM;");

		run_q ("CREATE TABLE IF NOT EXISTS {$mem}oekakichatmodusers (usrname varchar(255) NOT NULL DEFAULT '', lastmessage timestamp(14) NOT NULL, afk ENUM('no', 'yes') NOT NULL default 'no', PRIMARY KEY (usrname)) TYPE=MyISAM;");

		// Fail here before config is written
		$num_errs = count ($sql_errors);
		if ($num_errs > 0) {
			for ($i = $num_errs; $i > 0; $i--) {
				web_line ('MySQL: '.$sql_errors[$i - 1]);
			}
			web_line();
			web_line('<strong>STOP></strong>:  Update failed.  Check the database connection and run the updater again');
			fail_exit();
		}

		$fp = fopen ('config.php', 'w');
		fwrite ($fp, "<?\n \$saltenc=\"{$saltenc}\"; \n \$OPpics=\"{$OPpics}\"; \n \$killuser=\"{$killuser}\"; \n \$template=\"{$template}\"; \n \$BBStitle=\"{$BBStitle}\"; \n \$eaddr=\"{$eaddr}\"; \n \$okurl=\"{$okurl}\"; \n \$apostrophes=\"{$apostrophes}\"; \n \$pstore=\"{$pstore}\"; \n \$ppage=\"{$ppage}\"; \n \$approval=\"{$approval}\"; \n \$drawaccess=\"{$drawaccess}\"; \n \$animationaccess=\"{$animationaccess}\"; \n \$xCanvas=\"{$xCanvas}\"; \n \$yCanvas=\"{$yCanvas}\"; \n \$xDefault=\"{$xDefault}\"; \n \$yDefault=\"{$yDefault}\"; \n \$chatMax=\"{$chatMax}\"; \n \$chatDisp=\"{$chatDisp}\"; \n \$language=\"english\"; \n \$archivedir=\"{$archivedir}\"; \n \$guestpost=\"{$guestpost}\";\n \$anisize=\"{$anisize}\"; \n \$jpgcompression=\"no\"; \n \$jpgcompressqual=\"100\";?>");
		fclose ($fp);

	case ('5.0.0'):
		// Fix for MySQL 5 (don't add stuff yet)
		run_q ("ALTER TABLE {$mem}oekaki CHANGE templatesel templatesel varchar(255) NOT NULL DEFAULT ''");
		run_q ("ALTER TABLE {$mem}oekakichat CHANGE comment comment TINYTEXT NOT NULL DEFAULT ''");
		run_q ("ALTER TABLE {$mem}oekakichat CHANGE hostname hostname TEXT NOT NULL DEFAULT ''");
		run_q ("ALTER TABLE {$mem}oekakichat CHANGE `IP` `IP` TEXT NOT NULL DEFAULT ''");
		run_q ("ALTER TABLE {$mem}oekakionline CHANGE onlineIP onlineIP TEXT NOT NULL DEFAULT ''");
		run_q ("ALTER TABLE {$mem}oekakionline CHANGE onlineboard onlineboard TEXT NOT NULL DEFAULT ''");
		run_q ("ALTER TABLE {$mem}oekakimailbox CHANGE subject subject TEXT NOT NULL DEFAULT ''");
		run_q ("ALTER TABLE {$mem}oekakimailbox CHANGE body body LONGTEXT NOT NULL DEFAULT ''");
		run_q ("ALTER TABLE {$mem}oekakichatmod CHANGE comment comment TINYTEXT NOT NULL DEFAULT ''");
		run_q ("ALTER TABLE {$mem}oekakichatmod CHANGE hostname hostname TEXT NOT NULL DEFAULT ''");
		run_q ("ALTER TABLE {$mem}oekakichatmod CHANGE `IP` `IP` TEXT NOT NULL DEFAULT ''");
		run_q ("ALTER TABLE {$mem}oekakichatmodusers CHANGE usrname usrname VARCHAR(255) NOT NULL DEFAULT ''");

		run_q ("ALTER TABLE {$pre}oekakicmt CHANGE comment comment TEXT NOT NULL DEFAULT ''");
		run_q ("ALTER TABLE {$pre}oekakicmt CHANGE hostname hostname TEXT NOT NULL DEFAULT ''");
		run_q ("ALTER TABLE {$pre}oekakicmt CHANGE `IP` `IP` TEXT NOT NULL DEFAULT ''");
		run_q ("ALTER TABLE {$pre}oekakidta CHANGE comment comment TEXT NOT NULL DEFAULT ''");
		run_q ("ALTER TABLE {$pre}oekakidta CHANGE hostname hostname TEXT NOT NULL DEFAULT ''");
		run_q ("ALTER TABLE {$pre}oekakidta CHANGE `IP` `IP` TEXT NOT NULL DEFAULT ''");

		// Add avatars folder
		if (! (isset ($avatar_folder) && !empty ($avatar_folder)) ) {
			// Not set
			$avatar_folder = 'avatars';
		}
		if (!file_exists ($avatar_folder)) {
			if (! @mkdir ($avatar_folder, 0777)) {
				web_line('<strong>STOP</strong>: Could not create &ldquo;'.$avatar_folder.'&rdquo; folder.  Check your server permissions.');
				fail_exit();
			}
		}
		if (!is_writable ($avatar_folder)) {
			web_line('ERROR:  &ldquo;'.$avatar_folder.'&rdquo; folder is not writable.  CHMOD the folder to 755, 775, or 777 after the updater has finished.');
		}


		// Add to DB
		//$sql_errors = array();
		$fields = get_fields ($mem.'oekaki');
		if (!in_array ('avatar', $fields)) {
			run_q ("ALTER TABLE {$mem}oekaki ADD avatar VARCHAR(128) NOT NULL DEFAULT ''");
		} elseif ($debug) {
			web_line('Avatar field OK');
		}

		// Fail here before config is written
		$num_errs = count ($sql_errors);
		if ($num_errs > 0) {
			for ($i = $num_errs; $i > 0; $i--) {
				web_line ('MySQL: '.$sql_errors[$i - 1]);
			}
			web_line();
			web_line('<strong>STOP</strong>:  Cannot add avatar field to database.  Check the database connection and run the updater again');
			fail_exit();
		}


		// Verify "patch" values for wax < 5.5.5
		$gd_OK = 0;
		if (extension_loaded ('gd')) {
			// GDlib available!
			$gd_OK = 1;
		}
		if (!isset ($scale)) {
			// In case not in config file yet.
			$scale = 0;
			$scale_pix = 150;

			if ($gd_OK) {
				// Default on.  Hey, why not?
				$scale = 2;
			}
		}
		if (!isset ($uploadaccess))
			$uploadaccess = "no";
		if (!isset ($archivedir))
			$archivedir = "";
		if (!isset ($useChat))
			$useChat = "yes";

		// Update config file
		$fp = fopen ('config.php', 'w');
		$main_config = <<<EOF
<?php // Include only
	\$wax_cfg_ver = "5.5.6";
	\$saltenc = "{$saltenc}";
	\$OPpics = "{$OPpics}";
	\$killuser = "{$killuser}";
	\$template = "{$template}";
	\$BBStitle = "{$BBStitle}";
	\$eaddr = "{$eaddr}";
	\$okurl = "{$okurl}";
	\$apostrophes = "{$apostrophes}";
	\$pstore = "{$pstore}";
	\$ppage = "{$ppage}";
	\$approval = "{$approval}";
	\$drawaccess = "{$drawaccess}";
	\$animationaccess = "{$animationaccess}";
	\$uploadaccess = "{$uploadaccess}";
	\$xCanvas = "{$xCanvas}";
	\$yCanvas = "{$yCanvas}";
	\$xDefault = "{$xDefault}";
	\$yDefault = "{$yDefault}";
	\$useChat = "{$useChat}";
	\$chatMax = "{$chatMax}";
	\$chatDisp = "{$chatDisp}";
	\$language = "{$language}";
	\$archivedir = "{$archivedir}";
	\$guestpost = "{$guestpost}";
	\$anisize = "{$anisize}";
	\$jpgcompression = "{$jpgcompression}";
	\$jpgcompressqual = "{$jpgcompressqual}";
	\$scale = "{$scale}";
	\$scale_pix = "{$scale_pix}";
	\$use_avatars = "yes";
	\$use_c_avatars = "no";
	\$avatar_folder = "avatars";
	\$avatar_x = "50";
	\$avatar_y = "50";
?>
EOF;
		fwrite ($fp, $main_config, strlen ($main_config));
		fclose ($fp);

		// Remove files
		if (file_exists ('redirect.php') && !$debug) {
			@unlink ('redirect.php');
		}
		if (file_exists ('arecover.php') && !$debug) {
			@unlink ('arecover.php');
		}
		if (file_exists ('flagchk.php')) {
			@unlink ('flagchk.php');
		}

	case ('5.5.6'):
		// Lateset

	default:
		// Remove files
		if (file_exists ('install.php') && !$debug) {
			@unlink ('install.php');
		}
		break;
}


// All done!
mysql_close ($dbconn);

web_line();
web_line('Update complete! If you have multiple boards, make sure each board is at the current version.  If using avatars with multiple boards, please read the manual (short version:  the master board uses <strong>avatars/</strong>, all other &ldquo;slave&rdquo; boards use <strong>../board1/avatars/</strong>)');
web_line();
web_line("Don't forget to remove the installer and/or updater.");

exit();

?>